<?php

declare(strict_types=1);

/**
 * This file is part of the EaseHtml package
 *
 * https://github.com/VitexSoftware/php-ease-html
 *
 * (c) Vítězslav Dvořák <http://vitexsoftware.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Test\Ease\Html;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2016-01-17 at 23:59:23.
 */
class TextareaTagTest extends PairTagTest
{
    public string $rendered = '<textarea name="textarea"></textarea>';
    protected $object;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp(): void
    {
        $this->object = new \Ease\Html\TextareaTag('textarea');
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown(): void
    {
    }

    public function testConstructor(): void
    {
        $classname = \get_class($this->object);

        // Get mock, without the constructor being called
        $mock = $this->getMockBuilder($classname)
            ->disableOriginalConstructor()
            ->getMockForAbstractClass();
        $mock->__construct('Test');
        $mock->__construct('Textarea', 'Text');
        $this->assertEquals('<textarea name="Textarea">Text</textarea>', $mock->getRendered());
    }

    /**
     * @covers \Ease\Html\TextareaTag::setValue
     */
    public function testSetValue(): void
    {
        $this->object->setValue('test');
        $this->assertEquals('<textarea name="textarea">test</textarea>', $this->object->getRendered());
    }

    /**
     * @covers \Ease\Html\TextareaTag::getTagName
     */
    public function testGetTagName(): void
    {
        $this->assertEquals('textarea', $this->object->getTagName());
        $this->object->setName = true;
        $this->object->setTagName('Test');
        $this->assertEquals('Test', $this->object->getTagName());
    }
}
